// Es 5.3
#include <stdio.h>

#define N 4
#define M 2 // M è la radice quadrata di N


// funzione per controllare se la riga i non contiene numeri positivi ripetuti
int controlla_riga(int config[N][N], int i) {
	int j, controllo;
	int v[N]; 
	for (j=0; j<N; j++) {
		v[j] = 0;
	}

	// v[j-1] contiene il numero di occorrenze del numero j nella riga
	for (j=0; j<N; j++) {
		if (config[i][j] > 0) {
			v[config[i][j]-1]++;
		}
	}

	controllo = 1;
	for (j=0; j<N; j++) {
		if (v[j] > 1) {
			controllo = 0;
		}
	}
	return controllo;
}

// funzione per controllare se la colonna j non contiene numeri positivi ripetuti
int controlla_colonna(int config[N][N], int j) {
	int i, controllo;
	int v[N]; 
	for (i=0; i<N; i++) {
		v[i] = 0;
	}

	// v[i-1] contiene il numero di occorrenze del numero i nella colonna
	for (i=0; i<N; i++) {
		if (config[i][j] > 0) {
			v[config[i][j]-1]++;
		}
	}

	controllo = 1;
	for (i=0; i<N; i++) {
		if (v[i] > 1) {
			controllo = 0;
		}
	}
	return controllo;
}

// funzione per controllare se la regione con riquadro in alto a sinistra i,j non ha ripetizioni
int controlla_regione(int config[N][N], int i, int j) {
	int k,l, controllo;
	int v[N]; 
	for (k=0; k<N; k++) {
		v[k] = 0;
	}

	// v[j-1] contiene il numero di occorrenze del numero j nella regione
	for (k=0; k<M; k++) {
		for (l=0; l<M; l++) {
			if (config[i+k][j+l] > 0) {
				v[config[i+k][j+l]-1]++;
			}
		}
	}

	controllo = 1;
	for (k=0; k<N; k++) {
		if (v[k] > 1) {
			controllo = 0;
		}
	}
	return controllo;
}


int valido(int config[N][N]) {
	int v,i,j;
	int controllo;

	controllo = 1;

	// controllo tutte le righe
	for (i=0; i<N; i++) {
		controllo = controllo && controlla_riga(config,i);
	}

	// controllo tutte le colonne
	for (j=0; j<N; j++) {
		controllo = controllo && controlla_colonna(config,j);
	}

	// controllo tutti le regioni
	for (i=0; i<N; i+=M) {
		for (j=0; j<N; j+=M) {
			controllo = controllo && controlla_regione(config,i,j);
		}
	}
	
}


// funzione che controlla se la configurazione non contiene zeri
int completo(int config[N][N]) {
	int controllo,i,j;

	controllo = 1;

	for (i=0; i<N; i++) {
		for (j=0; j<N; j++) {
			if (config[i][j] == 0) {
				controllo = 0;
			}
		}
	}

	return controllo;
}

void stampa_sudoku(int config[N][N]){
	int i,j;

	for (i=0; i<N; i++) {
			for (j=0; j<N; j++) {
				printf("%d ",config[i][j]);
			}
			printf("\n");
		}
}

int risolvi(int config[N][N]) {
	int config_nuova[N][N];
	int i,j,k,l;
	int risolto,elemento;

	if (valido(config) && completo(config)) {
		printf("Sudoku risolto! \n");
			stampa_sodoku(config);
		return 1;
	}

	if (!valido(config)) {
		return 0;
	}

	// copio config dentro config_nuova e cerco un elemento diverso da zero
	for (k=0; k<N; k++) {
		for (l=0; l<N; l++) {
			config_nuova[k][l] = config[k][l];
			if (config_nuova[k][l] == 0) {
				i = k;
				j = l;
			}
		}
	}
	// i e j identificano una cella con lo 0

	risolto = 0;
	elemento = 0;
	do {
		elemento++;
		config_nuova[i][j] = elemento;
		risolto = risolvi(config_nuova);
	} while (!risolto && elemento < N);

	return risolto;
}

int main() {
	int config[N][N] = {{2,3,0,1},{0,0,2,0},{3,0,1,0},{4,0,3,0}};
	int risolto;

	printf("Sudoku iniziale:\n");
	stampa_sudoku(config);
	
	risolto = risolvi(config);
	
	if (risolto == 0) {
		printf("Sudoku impossibile\n");
	}
	return 0;
}
